#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <stdlib.h>
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "usb_config.h"
#include "USB/usb.h"
#include "USB/usb_host_bluetooth.h"
#include "user.h"
#include "xprintf.h"

#define PIN_CODE_DEFAULT	"0000"
#define BOARD_SBDBT32       1

// Define the baud rate constants UART1
#define	UARTPARAM1			UARTPARAM_N81			//data=8bit parity=none stopbit=1bit

#define BAUDRATE1       	115200
#define	USE_RFCOMM_BAUDRATE	1						//0:baud rate as fixed 1:baud rate as RFCOMM parameter from Master
#define BRG_DIV1        	4
#define BRGH1           	1
// Define Hardware Flow Control UART1 (0:off 1:on)
#define	UART1_HW_FLOW		0
#define	UART1_TX_POLARITY	0						//MMɐ 0:ʏ 1:]
#define	UART1_RX_POLARITY	0						//MMɐ 0:ʏ 1:]

// Define the baud rate constants UART2 (Debug)
#define BAUDRATE2       	115200
#define BRG_DIV2        	4
#define BRGH2           	1

// Define LED1 communication indicator on time(ms)
#define	LED1_ON_COUNT		10
#define	USE_RSSI			1						//0:blink rate as fixed 1:blink rate as RSSI (fast:lowRSSI slow:highRSSI)



#if BOARD_SBDBT32
#define LOCAL_NAME			"SBDBT32"
#define	ICSDEF				ICS_PGx1
#endif

#ifdef	__DEBUG
//disable watchdog timer
#define	FWDTENDEF			FWDTEN_OFF
#define	RestartWatchdog()
#define STO_SERIAL			1   //0:STO as I/O  1:STO as serial output
#else
//enable watchdog timer
#define	FWDTENDEF			FWDTEN_ON
#define	RestartWatchdog()	ClrWdt()
#define STO_SERIAL			0   //0:STO as I/O  1:STO as serial output
#endif

#if BOARD_SBDBT32

//
//for SBDBT32 board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

//scl:SBDBT32 PIN8:RD2
#define	scl_setup()			(TRISDbits.TRISD2=1,ODCDbits.ODCD2=1)	//input,pull-up
#define	ddr_set_scl()		(TRISDbits.TRISD2=0)
#define	ddr_reset_scl()		(TRISDbits.TRISD2=1)
#define	scl_h_mac()			(LATDbits.LATD2=1)
#define	scl_l_mac()			(LATDbits.LATD2=0)
#define	get_scl()			(PORTDbits.RD2)

//sda:SBDBT32 PIN9:RD9
#define	sda_setup()			(TRISDbits.TRISD9=1,ODCDbits.ODCD9=1)	//input,open-drain
#define	ddr_set_sda()		(TRISDbits.TRISD9=0)	//output
#define	ddr_reset_sda()		(TRISDbits.TRISD9=1)	//input
#define	sda_h()				(LATDbits.LATD9=1)
#define	sda_l()				(LATDbits.LATD9=0)
#define	get_sda()			(PORTDbits.RD9)

#if	STO_SERIAL
#define	sto_setup()
#define	sto_l()
#define	sto_h()
#else
#define	sto_setup()
#define	sto_l()
#define	sto_h()
#endif

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

#define	pairen_setup()
#define	get_pairen()		(1)

#endif


extern void (*usb_tick_handler)(void);
void	event_bluetooth_rxEvent_done(WORD size);
void	event_bluetooth_rxAcl_done(WORD size);

int init_adt7410(void);
int read_adt7410_temp100(long *temp);
#endif
