#include <stdlib.h>
#define USE_AND_OR /* To enable AND_OR mask setting */
//#include <ports.h>
//#include <pps.h>
//#include <outcompare.h>
//#include "global.h"
#include "btstack/debug.h"
#include "btstack/btstack.h"
#include <btstack/hci_cmds.h>
#include <btstack/run_loop.h>
#include <btstack/sdp_util.h>

#include "btstack/hci.h"
#include "btstack/l2cap.h"
#include "btstack/btstack_memory.h"
#include "btstack/remote_device_db.h"
#include "btstack/rfcomm.h"
#include "btstack/sdp.h"
//#include "btstack/config.h"
#include "uart1.h"

#define	CREDITS					 10


#define	led1_on_mac()			{led1_on(); led1_on_count=timer_counter; led1_on_state=1;}
static uint8_t		rfcomm_send_credit=CREDITS;
static uint8_t		rfcomm_channel_nr = 1;
static uint16_t		rfcomm_channel_id;
static uint8_t		spp_service_buffer[128];
static unsigned		timer_counter=0;
static unsigned		led1_on_count=0;
static uint8_t		led1_on_state=0;
char				lineBuffer[32];
static uint8_t		startup_state=0;
#if USE_RSSI
static unsigned		rssi_blink_rate_ms;
#endif
void (*usb_tick_handler)(void);	//sibu

hci_transport_t * hci_transport_picusb_instance();

#pragma config UPLLEN   = ON            // USB PLL Enabled
#pragma config FSRSSEL	= PRIORITY_7
#pragma config FPLLMUL  = MUL_20        // PLL Multiplier
#pragma config UPLLIDIV = DIV_2         // USB PLL Input Divider
#pragma config FPLLIDIV = DIV_2         // PLL Input Divider
#pragma config FPLLODIV = DIV_1         // PLL Output Divider
#pragma config FPBDIV   = DIV_1         // Peripheral Clock divisor
#pragma config FWDTEN   = OFF           // Watchdog Timer
#pragma config WDTPS    = PS8192        // Watchdog Timer Postscale
#pragma config FCKSM    = CSDCMD        // Clock Switching & Fail Safe Clock Monitor
#pragma config OSCIOFNC = OFF           // CLKO Enable
#pragma config POSCMOD  = HS            // Primary Oscillator
#pragma config IESO     = OFF           // Internal/External Switch-over
#pragma config FSOSCEN  = OFF           // Secondary Oscillator Enable (KLO was off)
#pragma config FNOSC    = PRIPLL        // Oscillator Selection
#pragma config CP       = OFF           // Code Protect
#pragma config BWP      = ON            // Boot Flash Write Protect
#pragma config PWP      = OFF           // Program Flash Write Protect
#pragma config ICESEL   = ICS_PGx1      // ICE/ICD Comm Channel Select
#pragma config DEBUG    = OFF           // Background Debugger Enable#else

BYTE        deviceAddress;  // Address of the device on the USB
bd_addr_t addr_global;

BOOL InitializeSystem ( void )
{
	SYSTEMConfigPerformance(GetSystemClock());
	INTEnableSystemMultiVectoredInt(); // Interrupt vectoring

	AD1PCFG=0x1FFF;

#if	1
	/* Initialize GPIO ports */
	LATB=	0x0000;
	TRISB=	0x3fff;		//RB14(LED1),RB15(LED2) as output
	CNPUEbits.CNPUE9=1;	//SDI2 Pull-up
	CNPUEbits.CNPUE7=1;	//MMC_CD Pull-up

	/* UART1 */
	LATD=	0x0000;
	TRISD=	0x000a;	//RD3(TX), RD1(RTS) as output

	/* SPI2 as MMC */
	LATG=	0x0000;
	TRISG=	0xfcbf;		//RG6(SCK), RG8(SDO), RG9(CS) as output
#endif

	on_setup();
	led1_setup();
	led2_setup();
//	u1rx_setup();
//	u1tx_setup();
//	u1cts_setup();
//	u1rts_setup();
//	sto_setup();
//	assoc_setup();
	pairen_setup();

	scl_setup();
	sda_setup();

	/* Start Timer1 in interval time of 1ms */
	OpenTimer1( T1_ON | T1_PS_1_256 | T1_SOURCE_INT,GetPeripheralClock()/256/1000);
	PR1 = GetPeripheralClock()/256/1000-1;
	mT1SetIntPriority(5);
	mT1ClearIntFlag();
	mT1IntEnable(1);

    // Init UART
    UART1Init(BAUDRATE1);
#if	STO_SERIAL
//    UART2Init();
#endif

    return TRUE;
} // InitializeSystem

BOOL USB_ApplicationEventHandler ( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
        BYTE i;
    #endif

    // Handle specific events.
    switch (event)
    {
        case EVENT_BLUETOOTH_ATTACH:
            if (size == sizeof(BLUETOOTH_DEVICE_ID))
            {
                deviceAddress   = ((BLUETOOTH_DEVICE_ID *)data)->deviceAddress;
                log_info( "Bluetooth device attached - event, deviceAddress=%d\r\n",deviceAddress );
                #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
                    for (i=1; i<((BLUETOOTH_DEVICE_ID *)data)->serialNumberLength; i++)
                    {
                        xputc( ((BLUETOOTH_DEVICE_ID *)data)->serialNumber[i] );
                    }
	                xputs( "\r\n" );
                #endif
                return TRUE;
            }
            break;

        case EVENT_BLUETOOTH_DETACH:
            deviceAddress   = 0;
            log_info( "Bluetooth device detached - event\r\n" );
            return TRUE;

        case EVENT_BLUETOOTH_TX_CMD_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_TX_ACL_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_RX_EVENT_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxEvent_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_BLUETOOTH_RX_ACL_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxAcl_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_VBUS_REQUEST_POWER:
            // We'll let anything attach.
            return TRUE;

        case EVENT_VBUS_RELEASE_POWER:
            // We aren't keeping track of power.
            return TRUE;

        case EVENT_HUB_ATTACH:
            log_info( "\r\n***** USB Error - hubs are not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSUPPORTED_DEVICE:
            log_info( "\r\n***** USB Error - device is not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_CANNOT_ENUMERATE:
            log_info( "\r\n***** USB Error - cannot enumerate device *****\r\n" );
            return TRUE;
            break;

        case EVENT_CLIENT_INIT_ERROR:
            log_info( "\r\n***** USB Error - client driver initialization error *****\r\n" );
            return TRUE;
            break;

        case EVENT_OUT_OF_MEMORY:
            log_info( "\r\n***** USB Error - out of heap memory *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSPECIFIED_ERROR:   // This should never be generated.
            log_info( "\r\n***** USB Error - unspecified *****\r\n" );
            return TRUE;
            break;

        case EVENT_SUSPEND:
        case EVENT_DETACH:
        case EVENT_RESUME:
        case EVENT_BUS_ERROR:
            return TRUE;
            break;

        default:
            break;
    }

    return FALSE;

} // USB_ApplicationEventHandler

// Bluetooth logic
static void packet_handler (void * connection, uint8_t packet_type, uint16_t channel, uint8_t *packet, uint16_t size)
{
//int i,j;
	bd_addr_t	event_addr;
    uint8_t		rfcomm_channel_nr;
    uint8_t		rfcomm_channel_id_temp;
    uint16_t	mtu;
    
	switch (packet_type) {
		case HCI_EVENT_PACKET:
			switch (packet[0]) {
				case BTSTACK_EVENT_STATE:
					// bt stack activated, get started - set local name
					if (packet[2] == HCI_STATE_WORKING) {
						if(
							!addr_global[0]
						&&	!addr_global[1]
						&&	!addr_global[2]
						&&	!addr_global[3]
						&&	!addr_global[4]
						&&	!addr_global[5]
						){
							//bd address failed -> reset
							Reset();
						}
//hci_send_cmd(&hci_read_local_supprted_commands);
						xsprintf(lineBuffer,LOCAL_NAME "-%02x%02x%02x%02x%02x%02x",
							addr_global[0],
							addr_global[1],
							addr_global[2],
							addr_global[3],
							addr_global[4],
							addr_global[5]
						);
						log_info("local name:%s\r\n",lineBuffer);
#ifndef	__DEBUG
						DelayMs(100);
#endif
                        hci_send_cmd(&hci_write_local_name, lineBuffer);
					}
					break;
				
				case HCI_EVENT_COMMAND_COMPLETE:
					if (COMMAND_COMPLETE_EVENT(packet, hci_read_bd_addr)){
                        bt_flip_addr(event_addr, &packet[6]);
                        log_info("BD-ADDR: %s\n\r", bd_addr_to_str(event_addr));
                        break;
                    }
					if (COMMAND_COMPLETE_EVENT(packet, hci_write_local_name)){
    				    hci_send_cmd(&hci_write_class_of_device, 0);
                        break;
                    }
					if (COMMAND_COMPLETE_EVENT(packet, hci_write_class_of_device)){
						if(get_pairen()){
							hci_discoverable_control(1);
						}
						startup_state=1;
                        break;
					}
#if	USE_RSSI
					if(COMMAND_COMPLETE_EVENT(packet,hci_read_rssi)){
						signed char rssi_value;
						unsigned blink_rate;
						if(packet[5]==0){		//status=0
							rssi_value=(signed char)(packet[8]);
							log_info("hci_read_rssi status=%d RSSI=%d\n",packet[5],rssi_value);

							//blink rate
							if(rssi_value>=0){
								blink_rate=30;
							}else
							if(rssi_value<=-30){
								blink_rate=0;
							}else{
								blink_rate=(unsigned)rssi_value+30;
							}
							rssi_blink_rate_ms=blink_rate*60+200;
						}else{
							rssi_blink_rate_ms=1000;
						}
					}
#endif
                    break;

				case HCI_EVENT_LINK_KEY_REQUEST:
					// deny link key request
                    log_info("Link key request\n\r");
                    bt_flip_addr(event_addr, &packet[2]);
					hci_send_cmd(&hci_link_key_request_negative_reply, &event_addr);
					break;
					
				case HCI_EVENT_PIN_CODE_REQUEST:
					// inform about pin code request
                    bt_flip_addr(event_addr, &packet[2]);
                    log_info("Pin code request - using '" PIN_CODE_DEFAULT "'\n\r");
					hci_send_cmd(&hci_pin_code_request_reply, &event_addr, 4, PIN_CODE_DEFAULT);
					break;
                
                case RFCOMM_EVENT_INCOMING_CONNECTION:
					// data: event (8), len(8), address(48), channel (8), rfcomm_cid (16)
					bt_flip_addr(event_addr, &packet[2]); 
					rfcomm_channel_nr = packet[8];
					rfcomm_channel_id_temp = READ_BT_16(packet, 9);
					log_info("RFCOMM channel %u requested for %s\n\r", rfcomm_channel_nr, bd_addr_to_str(event_addr));
                    rfcomm_accept_connection_internal(rfcomm_channel_id_temp);
					break;
					
				case RFCOMM_EVENT_OPEN_CHANNEL_COMPLETE:
					// data: event(8), len(8), status (8), address (48), server channel(8), rfcomm_cid(16), max frame size(16)
					if (packet[2]) {
						log_info("RFCOMM channel open failed, status %u\n\r", packet[2]);
					} else {
						rfcomm_channel_id = READ_BT_16(packet, 12);
						mtu = READ_BT_16(packet, 14);
						log_info("\n\rRFCOMM channel open succeeded. New RFCOMM Channel ID %u, max frame size %u\n\r", rfcomm_channel_id, mtu);
					}
					break;
                    
                case RFCOMM_EVENT_CHANNEL_CLOSED:
                    rfcomm_channel_id = 0;
                    break;
                
                default:
                    break;
			}
            break;
        case RFCOMM_DATA_PACKET:
            // hack: truncate data (we know that the packet is at least on byte bigger
            //packet[size] = 0;
            //xputs( (const char *) packet);
		    led1_on_mac();
			for(;size--;){
				UART1PutChar(*packet++);
			}
			if(!--rfcomm_send_credit){
	            rfcomm_send_credit = CREDITS;
		        rfcomm_grant_credits(rfcomm_channel_id, rfcomm_send_credit);
			}
			break;

        default:
            break;
	}
}

#if USE_RSSI
#define HEARTBEAT_PERIOD_MS		1000

static void  heartbeat_handler(struct timer *ts)
{
int rfcomm_read_rssi(uint16_t rfcomm_cid);
    if (rfcomm_channel_id){
        int err = rfcomm_read_rssi(rfcomm_channel_id);
        if (err) {
            xprintf("rfcomm_read_rssi -> error %d\n", err);
        }
    }

    run_loop_set_timer(ts, HEARTBEAT_PERIOD_MS);
    run_loop_add_timer(ts);
} 
#endif

int main ( void )
{
	RestartWatchdog();

    // Initialize the processor and peripherals.
    if ( InitializeSystem() != TRUE )
    {
        //log_info( "\r\n\r\nCould not initialize " LOCAL_NAME " - system.  Halting.\r\n\r\n" );
#ifdef __DEBUG
        while (1);
#else
		Reset();
#endif
    }
	xdev_out(UART1PutChar);

    if ( USBHostInit(0) == TRUE )
    {
        log_info( "\r\n\r\n***** " LOCAL_NAME " Initialized *****\r\n\r\n" );
    }
    else
    {
        log_info( "\r\n\r\nCould not initialize " LOCAL_NAME " - USB.  Halting.\r\n\r\n" );
#ifdef __DEBUG
		while (1);
#else
		Reset();
#endif
    }
	init_adt7410();

    // Main Processing Loop
    while(!deviceAddress)
    {
        // This demo does not check for overcurrent conditions.  See the
        // USB Host - Data Logger for an example of overcurrent detection
        // with the PIC24F and the USB PICtail Plus.

        // Maintain USB Host State
        USBHostTasks();

        //if (CheckForNewAttach()){
		//	break;
        //}
    }

	DelayMs(1000);

	led2_off();

	/// GET STARTED with BTstack ///
	btstack_memory_init();
    run_loop_init(RUN_LOOP_EMBEDDED);
	
    // init HCI
	hci_transport_t    * transport = hci_transport_picusb_instance();
	bt_control_t       * control   = NULL;
    hci_uart_config_t  * config    = NULL;
    remote_device_db_t * remote_db = (remote_device_db_t *) &remote_device_db_memory;
	hci_init(transport, config, control, remote_db);

    // use eHCILL
//    bt_control_cc256x_enable_ehcill(1);
    
    // init L2CAP
    l2cap_init();
    l2cap_register_packet_handler(packet_handler);
    
	// init RFCOMM
    rfcomm_init();
    rfcomm_register_packet_handler(packet_handler);
    rfcomm_register_service_with_initial_credits_internal(NULL, rfcomm_channel_nr, 100, CREDITS);  // reserved channel, mtu=100, 1 credit

    // init SDP, create record for SPP and register with SDP
    sdp_init();

	memset(spp_service_buffer, 0, sizeof(spp_service_buffer));
    service_record_item_t * service_record_item = (service_record_item_t *) spp_service_buffer;
    sdp_create_spp_service( (uint8_t*) &service_record_item->service_record, 1, "SPP");
    log_info("SDP service buffer size: %u\n\r", (uint16_t) (sizeof(service_record_item_t) + de_get_len((uint8_t*) &service_record_item->service_record)));
    sdp_register_service_internal(NULL, service_record_item);

#if USE_RSSI
    // set one-shot timer
    timer_source_t heartbeat;
    heartbeat.process = &heartbeat_handler;
    run_loop_set_timer(&heartbeat, HEARTBEAT_PERIOD_MS);
    run_loop_add_timer(&heartbeat);
#endif

 	// turn on!
	hci_power_control(HCI_POWER_ON);

extern linked_list_t db_mem_link_keys;
void load_link_keys(remote_device_db_t * lpremote_device_db);
void print_link_keys(linked_list_t list);
	load_link_keys(remote_db);
	print_link_keys(db_mem_link_keys);

    led1_off();

    // go!
    run_loop_execute();	

    return 0;

} // main


void hal_tick_init(void)
{
	usb_tick_handler=NULL;
}

void hal_tick_set_handler(void (*tick_handler)(void))
{
	usb_tick_handler=tick_handler;
}

void __ISR( _TIMER_1_VECTOR, ipl5) T1Interrupt(void)
{
	mT1ClearIntFlag();

	timer_counter++;

	RestartWatchdog();

#ifndef __DEBUG
	if(!startup_state && timer_counter>5000){
		Reset();
	}
#endif

    if (rfcomm_channel_id){
        if(timer_counter&0x100){
            //led2_off();
			assoc_l();
        }else{
            //led2_on();
			assoc_h();
        }
#if	USE_RSSI
		if(rssi_blink_rate_ms && (timer_counter%rssi_blink_rate_ms)<100){
            led2_on();
        }else{
            led2_off();
        }
#else
        if(timer_counter&0x100){
            led2_off();
        }else{
            led2_on();
        }
#endif
		sto_h();
    }else{
        led2_on();
		sto_l();
		assoc_l();
    }

	if(led1_on_state && (timer_counter-led1_on_count)>LED1_ON_COUNT){
		led1_off();
		led1_on_state=0;
	}

	// call tick handler
	if(usb_tick_handler){
		usb_tick_handler();
	}
}

void sendchar(void)
{
//	int				ch;
	unsigned		len;
	long			lt;
	static unsigned	last_counter;

#if	1
	if(is_rfcomm_send_avail(rfcomm_channel_id)){
		//can't send rfcomm now
		return;
	}

	if((timer_counter-last_counter)<1000){
		return;
	}
	last_counter=timer_counter;

	if(read_adt7410_temp100(&lt)){
		xsprintf(lineBuffer,"adt7410 error\n");
	}else{
		xsprintf(lineBuffer,"%4d.%02u\n",(int)(lt/100),abs((int)(lt%100)));
	}
	log_info(lineBuffer);
	len=strlen(lineBuffer);
	if(len){
	    led1_on_mac();
        int err = rfcomm_send_internal(rfcomm_channel_id, (uint8_t*) lineBuffer, len);
        if (err) {
            log_error("rfcomm_send_internal -> error %d", err);
        }
	}
#else
	if((timer_counter-last_counter)<1000){
		return;
	}
	last_counter=timer_counter;

	if(read_adt7410_temp100(&lt)){
		xsprintf(lineBuffer,"adt7410 error\n");
	}else{
		xsprintf(lineBuffer,"%4d.%02u\n",(int)(lt/100),abs((int)(lt%100)));
	}
	log_info(lineBuffer);
#endif

}


void _general_exception_handler( unsigned long ulCause, unsigned long ulStatus )
{
	/* This overrides the definition provided by the kernel.  Other exceptions 
	should be handled here. */
#ifdef	__DEBUG
	led1_on();
#else
	Reset();
#endif
	for( ;; );
}

/*************************************************************************
 * EOF main.c
 */

